#ifdef BGE_COCONUT
#include "shaders/common/postfx/hdr/ACES.h.hlsl"
#endif

// http://de.slideshare.net/ozlael/hable-john-uncharted2-hdr-lighting
float3 TonemapOperatorUncharted2(float3 x)
{
    const float3 AVERAGE_LUMINANCE = float3( 0.3333, 0.3333, 0.3333 );
    x *= 0.5;
    float a = 0.8 * AVERAGE_LUMINANCE; //toeStrength
    float b = 0.02f; //toeLength
    float c = 1.53f; //shoulderStrength
    float d = 0.99f; //shoulderLength
    float e = 1.04f; //shoulderAngle
    return clamp((x*(a*x+b))/(x*(c*x+d)+e), 0.0f, 1.0f);
}

float3 TonemapUncharted2(float3 color)
{
    const float3 AVERAGE_LUMINANCE = float3( 0.3333, 0.3333, 0.3333 );
    const float exposure_adjustment = 3; //16;  //AL values
    const float exposure_bias = 0.3 / AVERAGE_LUMINANCE; //2;

    color = max(color, 0) * exposure_adjustment;
    const float whiteScale = (1.0f / TonemapOperatorUncharted2(11.2f)).x;
    return saturate(TonemapOperatorUncharted2(exposure_bias * color) * whiteScale);
}

float3 tonemap(float3 rgb) {
#ifdef BGE_COCONUT
    return toLinearColor(ACESFitted(linearToGammaColor(rgb)));
#else
   return TonemapUncharted2(rgb);
#endif
}